#!/bin/bash
#set -n		# read but do not execute commands (check on syntax errors)
#
# File: /usr/local/bin/mediatitle
#
# Set or remove title and/or comment.
#
#    Copyright (c) 2020  Juergen Kaesmann (JK)
#
##############################################################################
# GPL NOTICE
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
# FIND SAMPLES
#
##############################################################################
# FILTER SAMPLES
#
##############################################################################
# AWK SAMPLES
#
##############################################################################
# SED SAMPLES
#
##############################################################################
# RSYNC OPTIONS
#
##############################################################################
# DIALOG SAMPLES
#
##############################################################################
# REPLACE STRINGS
#
##############################################################################
# EXIT CODES

##############################################################################
# SOURCE FILES
#
. /usr/local/etc/main.conf				# config main
#. $LLIBDIR/libfuncerr-sh				# functions error
. $LLIBDIR/libfuncstd-sh				# functions standard
#. $LLIBDIR/libfuncmath2-sh				# functions math2
#. $LLIBDIR/libfuncip-sh				# functions IP
#. /usr/local/etc/sample.conf				# config sample

#if [ ! -e ~/.samplerc ]; then				# install config user
#	cp /usr/local/share/ksm-sample/samplerc ~/.samplerc
#	echo "Please configure your ~/.samplerc"
#	exit 1
#fi
#. ~/.samplerc						# config user

##############################################################################
# DECLARATION OF STANDARD CONSTANTS AND VARIABLES
#
readonly package=Multimedia				# package name
readonly package_file=ksm-multimedia			# package file name
readonly vinfopath="/usr/local/share/$package_file"	# path to package dir
readonly version=$(/bin/cat $vinfopath/VERSION)		# package version
readonly release=$(/bin/cat $vinfopath/RELEASE)		# package release
readonly scriptname=$(basename $0)			# name of script
#readonly tempfile=$TEMPDIR/$scriptname.$UID.tmp	# temporary file name
#tempfile=$(mktemp $TEMPDIR/$scriptname.$UID.XXXXXX)	# temporary file name
#readonly lockfile=$TEMPDIR/lock/$scriptname.$UID.lock	# lock file name
readonly debuglog="/usr/bin/logger -p user.debug -t $scriptname -- DEBUG:"	# log dbg msg
readonly errlog="/usr/bin/logger -p user.err -t $scriptname -- ERROR:"		# log err msg
readonly infolog="/usr/bin/logger -p user.info -t $scriptname -- INFO:"		# log inf msg
cmd=''							# sub command
debug=no						# debug=yes/no
verbose=''						# verbose=yes/''/no
err=${_ERR_OK_}						# error code

##############################################################################
# USER FILL IN AT FIRST RUN

##############################################################################
# SYSTEM

##############################################################################
# USER-CONSTANTS

##############################################################################
# USER-VARIABLES
#
# STRINGS
#args=''				# all args from cmdline
arg1=''					# 1. arg from cmdline
arg2=''					# 2. arg from cmdline
#opt_o=''				# option -o (yes)
					# option --output (yes)
#opt_i=''				# option -i (arg)
					# option --infile (arg)
#opt_o=''				# option -o (arg)
					# option --outfile (arg)
#opt_p=''				# option -p (arg)
					# option --pages (arg)
opt_c=''				# option -c (arg)
opt_t=''				# option -t (arg)
flag_c=no
flag_t=no

# NUMBERS
#p_first=0				# first page
#p_last=0				# last page

# ARRAYS
# Indexed arrays are always zero based string arrays.
# If index starts with 1 and all members are assigned then
# count of members of array = last index of array
#declare -a arr
#maxarr="${#arr[@]}"			# get number of elements in arr
#unset arr[@]				# remove the entire array

##############################################################################
# SIGNAL HANDLING

##############################################################################
# FUNCTIONS
##############################################################################
#
##############################################################################
# HELP
#
#=============================================================================
function helptext ()
{
# Output helptext
# Uses cat, echo, logger
# Return codes:
# Standard

if [ "$debug" == "yes" ]; then				# DEBUG
	echo "DEBUG helptext: $# $@" >&2
	$debuglog helptext: $# $@
fi

cat <<EOT
NAME
$scriptname - Set or remove title and/or comment.

SYNOPSIS
$scriptname [options] [inf [outf]]

DESCRIPTION
Set or remove title and/or comment in a mediafile. Streams are copied
as they are.

Defaults:  cmd = -r, build outf from inf (prepended with 'n').

OPTIONS
Gnu style options:

  -h|--help    = Output help, then exit.
  -V|--version = Output version info, then exit.
  -d|--debug   = Turn on DEBUG mode.
  -q|--quiet   = Be quiet.
  -v|--verbose = Be verbose.
  -c com       = Set comment (give spaces as '_' ).
                 To delete comment give one '_'
  -t tit       = Set title (give spaces as '_' ).
                 To delete title give one '_'
  -r           = Remove comment and title
  --           = End of options.

ARGUMENTS
Give if needed:

  inf  = The input file.
  outf = The output file.

EXIT STATUS
On program exit:

  Code 0 = OK

  See output of 'showerrmsg'.

SEE ALSO
Related manpages:

  showerrmsg(1), ffmpeg(1), media2media(1).

AUTHORS
Juergen Kaesmann <juergen@kaesmann-online.de>
EOT
#  -o|--output  = Output to STDOUT.
#  -i f         = Input from file <f>.
#  --infile=f   = Input from file <f>.
#  -o f         = Output to file <f>.
#  --outfile=f  = Output to file <f>.
#  -p s,e       = Pages s=START e=END.
#  --pages=s,e  = Pages s=START e=END.

#EXAMPLES
#For instance:
#
#  Do it:
#  $scriptname

#FILES
#Used directories and files:
#
#  Config Global = /usr/local/etc/sample.conf
#  Config User   = ~/.samplerc

return
}

#=============================================================================
function mainproc ()
{
# (Re)Set title and/or comment.
# par1 = 
# Uses echo, logger
# Return codes:
# Standard

if [ "$debug" == "yes" ]; then				# DEBUG
	echo "DEBUG mainproc: $# $@" >&2
	$debuglog mainproc: $# $@
fi

local ret=0
#local -a arr
#maxarr="${#arr[@]}"			# get number of elements in arr
#unset arr[@]				# remove the entire array

# change all _ to space
if [ -n "$opt_c" ]; then
	flag_c=yes
	opt_c="${opt_c//_/ }"
	if [ "$opt_c" == " " ]; then opt_c=""; fi
fi
if [ -n "$opt_t" ]; then
	flag_t=yes
	opt_t="${opt_t//_/ }"
	if [ "$opt_t" == " " ]; then opt_t=""; fi
fi

case "$verbose" in
    yes)					# allow STDOUT and STDERR
	echo "Run $scriptname"
	if [ "$flag_c" == yes ] && [ "$flag_t" == yes ]; then	# title and comment given
		ffmpeg -i $arg1 -vcodec copy -acodec copy -metadata title="$opt_t" -metadata comment="$opt_c" $arg2
		ret=$?
	elif [ "$flag_t" == yes ]; then				# title given
		ffmpeg -i $arg1 -vcodec copy -acodec copy -metadata title="$opt_t" $arg2
		ret=$?
	else							# comment given
		ffmpeg -i $arg1 -vcodec copy -acodec copy -metadata comment="$opt_c" $arg2
		ret=$?
	fi
	;;
    '')						# suppress STDOUT or STDERR
	#echo "Run $scriptname"
	if [ "$flag_c" == yes ] && [ "$flag_t" == yes ]; then	# title and comment given
		ffmpeg -hide_banner -y -i $arg1 -vcodec copy -acodec copy -metadata title="$opt_t" -metadata comment="$opt_c" $arg2 2>/dev/null
		#1>/dev/null
		ret=$?
	elif [ "$flag_t" == yes ]; then				# title given
		ffmpeg -hide_banner -y -i $arg1 -vcodec copy -acodec copy -metadata title="$opt_t" $arg2 2>/dev/null
		#1>/dev/null
		ret=$?
	else							# comment given
		ffmpeg -hide_banner -y -i $arg1 -vcodec copy -acodec copy -metadata comment="$opt_c" $arg2 2>/dev/null
		#1>/dev/null
		ret=$?
	fi
	;;
    no)						# suppress STDOUT and STDERR
	if [ "$flag_c" == yes ] && [ "$flag_t" == yes ]; then	# title and comment given
		ffmpeg -hide_banner -y -i $arg1 -vcodec copy -acodec copy -metadata title="$opt_t" -metadata comment="$opt_c" $arg2 &>/dev/null
		ret=$?
	elif [ "$flag_t" == yes ]; then				# title given
		ffmpeg -hide_banner -y -i $arg1 -vcodec copy -acodec copy -metadata title="$opt_t" $arg2 &>/dev/null
		ret=$?
	else							# comment given
		ffmpeg -hide_banner -y -i $arg1 -vcodec copy -acodec copy -metadata comment="$opt_c" $arg2 &>/dev/null
		ret=$?
	fi
	;;
esac

if [ "$ret" -ne 0 ]; then				# for other progs
	if [ "$verbose" != no ]; then
		echo "${ErrMsg[${_ERR_GENERAL_}]} $ret from ffmpeg!" >&2
	else
		$errlog ${ErrMsg[${_ERR_GENERAL_}]} $ret from ffmpeg
	fi
	ret=${_ERR_GENERAL_}
fi

return $ret
}

##############################################################################
# GET OPTIONS
##############################################################################
# Give 2 strings and all cmdline_args to func GetOpt
# (POSIX_options Gnu_long_options cmdline_args):
# GetOpt 'hVdqvi:m:' 'help version debug quiet verbose infile= myval=' $@
#
# A ':' after a POSIX option means this option needs an arg.
# A '=' after a Gnu long option means this option needs an arg.
#
# All cmd/options have to be initialised to ''!
#
# Options are divided in 2 classes:
#   a) cmds (mutually exclusive). All cmds are given to var 'cmd'.
#   b) options (as many as you like). Each option is given to it's own var.
# As a general rule: If cmds/options are given multiple then last given wins.
#
# Options can take 1 argument (no whitespace in arg). If you want to give more
# than 1 arg or want to use multiple strings as 1 arg then concatenate them
# together with a delimiter like ',' or ';' or '.'
# Use a delimiter which will not be part of the arg:
# sampleprog -m val1,val2
# sampleprog --myval=val1,val2
# It's at the programmers responsibility to do meaningfull things with the
# content of the options.
#
# While err = 0 then look for a next option.
# When GetOpt finishes then all options are removed from cmdline.
#
if [ "$debug" == "yes" ]; then				# DEBUG
	echo "DEBUG Parse Commandline: $# $@" >&2
	$debuglog Parse Commandline: $# $@
fi
#
err=0
while [ "$err" -eq 0 ]; do
	GetOpt 'hVdqvc:rt:' 'help version debug quiet verbose' $@
	err=$?
	#echo "DEBUG GET OPTIONS: err=${err}  _OPTNAME_=${_OPTNAME_}  _OPTVAL_=${_OPTVAL_}  _OPTPOS_=${_OPTPOS_}  _OPTIDX_=${_OPTIDX_}" >&2
	if [ $err -eq 0 ]; then
		case "$_OPTNAME_" in
		    h|help)	cmd="-h";;
		    V|version)	cmd="-V";;
		    r)		cmd="-${_OPTNAME_}";;
		    d|debug)	debug=yes;;
		    q|quiet)	verbose=no;;
		    v|verbose)	verbose=yes;;
#		    o|output)	opt_o=yes;;
#		    i|infile)	opt_i="${_OPTVAL_}";;
#		    outfile)	opt_outfile="${_OPTVAL_}";;
#		    p|pages)	opt_p="${_OPTVAL_}";;
		    c)		opt_c="${_OPTVAL_}";;
		    t)		opt_t="${_OPTVAL_}";;
		    --)		break;;
		    :)	if [ "$verbose" != no ]; then
				echo "${ErrMsg[8]} -${_OPTVAL_}" >&2
			else
				$errlog ${ErrMsg[8]} -${_OPTVAL_}
			fi; exit 8;;
		    ?)	if [ "$verbose" != no ]; then
				echo "${ErrMsg[4]} -${_OPTVAL_}" >&2
			else
				$errlog ${ErrMsg[4]} -${_OPTVAL_}
			fi; exit 4;;
		    *)	if [ "$verbose" != no ]; then
				echo "${ErrMsg[99]} _OPTNAME_=${_OPTNAME_} _OPTVAL_=${_OPTVAL_}" >&2
			else
				$errlog ${ErrMsg[99]} _OPTNAME_=${_OPTNAME_} _OPTVAL_=${_OPTVAL_}
			fi; exit 99;;
		esac
	fi
done
err=0
shift ${_OPTIDX_}				# rm all opts from cmdline
# Uncomment if giving a cmd is mandatory
#if [ -z "$cmd" ]; then					# error no cmd given
#	if [ "$verbose" != no ]; then
#		echo "${ErrMsg[7]}" >&2
#	else
#		$errlog ${ErrMsg[7]}
#	fi
#	exit 7
#fi

##############################################################################
# CHECK LINK NAMES

##############################################################################
# CHECK OPTIONS
#
#-----------------------------------------------------------------------------
# check not allowed option for sub commands
case "$cmd" in
    -r)							# for these cmds
	if [ -n "$opt_c" ] || [ -n "$opt_t" ]; then	# option -c or -t not allowed
		if [ "$verbose" != no ]; then
			echo "${ErrMsg[13]} -z" >&2
		else
			$errlog ${ErrMsg[13]} -z
		fi
		exit 13
	fi
	;;
    *)							# for all other cmds ok
	:
	;;
esac
#
#-----------------------------------------------------------------------------
# check allowed option for sub commands
#if [ -n "$opt_z" ]; then
#	case "$cmd" in
#	    -l|-p)					# for these cmds
#		:					# option -z allowed
#		;;
#	    *)						# for all other cmds
#		if [ "$verbose" != no ]; then
#			echo "${ErrMsg[13]} -z" >&2
#		else
#			$errlog ${ErrMsg[13]} -z
#		fi
#		exit 13
#		;;
#	esac
#fi
#
#-----------------------------------------------------------------------------
# check needed option for sub commands
#case "$cmd" in
#    -l|-p)						# for these cmds
#	if [ -z "$opt_z" ]; then			# option -z needed
#		if [ "$verbose" != no ]; then
#			echo "${ErrMsg[8]} -z" >&2
#		else
#			$errlog ${ErrMsg[8]} -z
#		fi
#		exit 8
#	fi
#	;;
#    *)							# for all other cmds
#	:
#	;;
#esac
#
#-----------------------------------------------------------------------------
# check options which are mutually exclusive
#if [ -n "$opt_x" ] && [ -n "$opt_y" ]; then		# don't give both opts
#		if [ "$verbose" != no ]; then
#			echo "${ErrMsg[13]} -x and -y given" >&2
#		else
#			$errlog ${ErrMsg[13]} -x and -y given
#		fi
#		exit 13
#fi
#
#-----------------------------------------------------------------------------
# check option which needs another option
#if [ -n "$opt_x" ]; then			# opt_x given
#	if [ -z "$opt_y" ]; then		# error - opt_x needs opt_y
#		if [ "$verbose" != no ]; then
#			echo "${ErrMsg[1]} -x needs -y" >&2
#		else
#			$errlog ${ErrMsg[1]} -x needs -y
#		fi
#		exit 1
#	fi
#fi
#
#-----------------------------------------------------------------------------
# check options which needs to give at least one of them
#case "$cmd" in
#    '')
#	if [ -z "$opt_c" ] && [ -z "$opt_t" ]; then	# no option given
#		if [ "$verbose" != no ]; then
#			echo "${ErrMsg[1]} give -c and/or -t" >&2
#		else
#			$errlog ${ErrMsg[1]} give -c and/or -t
#		fi
#		exit 1
#	fi
#esac
#
#-----------------------------------------------------------------------------
# get values from arg of option -p to vars p_first p_last
#if [ -n "$opt_p" ]; then
#	p_first="${opt_p%,*}"
#	p_last="${opt_p#*,}"
#fi

##############################################################################
# CHECK VERSION

##############################################################################
# CHECK ARGUMENTS
#
case "$cmd" in
    ''|-r)
	if [ "$#" -eq 1 ]; then				# parameter count ok
		arg1="$1"
		arg2="n$1"
		shift
		#args="$@"
		#shift $#
	elif [ "$#" -eq 2 ]; then			# parameter count ok
		arg1="$1"
		arg2="$2"
		shift 2
		#args="$@"
		#shift $#
	else						# error in param count
		if [ "$verbose" != no ]; then
			echo "${ErrMsg[2]}" >&2
		else
			$errlog ${ErrMsg[2]}
		fi
		exit 2
	fi
	;;
    *)
	if [ "$#" -ne 0 ]; then				# error in param count
		if [ "$verbose" != no ]; then
			echo "${ErrMsg[2]}" >&2
		else
			$errlog ${ErrMsg[2]}
		fi
		exit 2
	fi
	;;
esac

##############################################################################
# LOCK

##############################################################################
# MAINPROGRAM
##############################################################################
#
if [ "$debug" == "yes" ]; then				# DEBUG
	echo "DEBUG Main: $# $@" >&2
	$debuglog Main: $# $@
fi

if [ -z "$cmd" ] && [ -z "$opt_c" ] && [ -z "$opt_t" ]; then
	cmd="-r"
fi

# Check what to do (sub commands, options and args are removed from cmdline)
case "$cmd" in
    '')
	mainproc
	err=$?
	;;
    -h)
	helptext
	exit 0
	;;
    -V)
	echo "${scriptname}: (${package}) $package_file ${version}-${release}"
	exit 0
	;;
    -r)
	opt_c="_"
	opt_t="_"
	mainproc
	err=$?
	;;
    *)							# error
	Show_Err ${_ERR_SUB_CMD_NOT_FOUND_} ""
	err=${_ERR_SUB_CMD_NOT_FOUND_}
	;;
esac

#rm -f $lockfile

exit $err
